(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@triangular/bootstrap-icons', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.triangular = global.triangular || {}, global.triangular['bootstrap-icons'] = {}), global.ng.core, global.ng.common));
}(this, (function (exports, i0, common) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);

    var BootstrapIconsRegistry = /** @class */ (function () {
        function BootstrapIconsRegistry() {
            this.registry = new Map();
        }
        BootstrapIconsRegistry.prototype.registerIcons = function (icons) {
            var _this = this;
            icons.forEach(function (icon) { return _this.registry.set(icon.name, icon.data); });
        };
        BootstrapIconsRegistry.prototype.getIcon = function (iconName) {
            if (!this.registry.has(iconName)) {
                console.warn("We could not find the dinosaur Icon with the name " + iconName + ", did you add it to the Icon registry?");
            }
            return this.registry.get(iconName);
        };
        return BootstrapIconsRegistry;
    }());
    BootstrapIconsRegistry.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: BootstrapIconsRegistry, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    BootstrapIconsRegistry.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: BootstrapIconsRegistry, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: BootstrapIconsRegistry, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }] });

    var BootstrapIconComponent = /** @class */ (function () {
        function BootstrapIconComponent(element, iconsRegistry, document) {
            this.element = element;
            this.iconsRegistry = iconsRegistry;
            this.document = document;
        }
        Object.defineProperty(BootstrapIconComponent.prototype, "name", {
            set: function (iconName) {
                if (this.svgIcon) {
                    this.element.nativeElement.removeChild(this.svgIcon);
                }
                var svgData = this.iconsRegistry.getIcon(iconName);
                if (svgData) {
                    this.svgIcon = this.svgElementFromString(svgData);
                    this.element.nativeElement.appendChild(this.svgIcon);
                }
            },
            enumerable: false,
            configurable: true
        });
        BootstrapIconComponent.prototype.svgElementFromString = function (svgContent) {
            var div = this.document.createElement('DIV');
            if (div instanceof HTMLElement) {
                div.innerHTML = svgContent;
                return div.querySelector('svg') || this.document.createElementNS('http://www.w3.org/2000/svg', 'path');
            }
        };
        return BootstrapIconComponent;
    }());
    BootstrapIconComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: BootstrapIconComponent, deps: [{ token: i0__namespace.ElementRef }, { token: BootstrapIconsRegistry }, { token: common.DOCUMENT, optional: true }], target: i0__namespace.ɵɵFactoryTarget.Component });
    BootstrapIconComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.0", type: BootstrapIconComponent, selector: "bootstrap-icon", inputs: { name: "name" }, ngImport: i0__namespace, template: "<ng-content></ng-content>", isInline: true, changeDetection: i0__namespace.ChangeDetectionStrategy.OnPush, encapsulation: i0__namespace.ViewEncapsulation.None });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: BootstrapIconComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'bootstrap-icon',
                        template: "<ng-content></ng-content>",
                        encapsulation: i0.ViewEncapsulation.None,
                        changeDetection: i0.ChangeDetectionStrategy.OnPush
                    }]
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ElementRef }, { type: BootstrapIconsRegistry }, { type: undefined, decorators: [{
                            type: i0.Optional
                        }, {
                            type: i0.Inject,
                            args: [common.DOCUMENT]
                        }] }];
        }, propDecorators: { name: [{
                    type: i0.Input
                }] } });

    var BootstrapIconsModule = /** @class */ (function () {
        function BootstrapIconsModule() {
        }
        BootstrapIconsModule.forRoot = function () {
            return {
                ngModule: BootstrapIconsModule,
                providers: [
                    BootstrapIconsRegistry,
                ],
            };
        };
        return BootstrapIconsModule;
    }());
    BootstrapIconsModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: BootstrapIconsModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    BootstrapIconsModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: BootstrapIconsModule, declarations: [BootstrapIconComponent], exports: [BootstrapIconComponent] });
    BootstrapIconsModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: BootstrapIconsModule, imports: [[]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.0", ngImport: i0__namespace, type: BootstrapIconsModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [BootstrapIconComponent],
                        imports: [],
                        exports: [BootstrapIconComponent]
                    }]
            }] });

    /*
     * Public API Surface of the icons lib
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.BootstrapIconComponent = BootstrapIconComponent;
    exports.BootstrapIconsModule = BootstrapIconsModule;
    exports.BootstrapIconsRegistry = BootstrapIconsRegistry;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=triangular-bootstrap-icons.umd.js.map
